# Hashtastic

Welcome to your new gem! In this directory, you'll find the files you need to be able to package up your Ruby library into a gem. Put your Ruby code in the file `lib/hashtastic`. To experiment with that code, run `bin/console` for an interactive prompt.

TODO: Delete this and the text above, and describe your gem

## Installation

Add this line to your application's Gemfile:

```ruby
gem 'hashtastic', '~> 0.1.2'
```

And then execute:

    $ bundle

Or install it yourself as:

    $ gem install hashtastic

## Usage

Embedded in your application

```sh
require 'hashtastic'
```

```rb
Hashtastic::EthereumSHA3.call('a')

=> '0x3ac225168df54212a25c1c01fd35bebfea408fdac2e31ddd6f80a4bbf9a5f1cb'
```

```rb
Hashtastic::ListHasher.call(%w(a b c))

=> '4e03657aea45a94fc7d47ba826c8d667c0d1e6e33a64a036ec44f58fa12d6c45'
```

```rb
metrics = {
  advertiser_id: '1234',
  agency_id: '1234',
  app_id: '212',
  campaign_id: '123',
  channel_id: 'adelphic',
  clicks: 10,
  conversions: 1,
  decision_cost: 1000,
  decision_win_impressions: 10,
  exchange_id: '1234',
  impressions: 100,
  loaded_impressions: 20,
  publisher_id: '123456',
  site_id: '1234',
  win_cost: 1000
}.with_indifferent_access

values_at = %w(
  advertiser_id
  agency_id
  app_id
  campaign_id
  channel_id
  clicks
  conversions
  decision_cost
  decision_win_impressions
  exchange_id
  impressions
  loaded_impressions
  publisher_id
  site_id
  win_cost
).sort.freeze

Hashtastic::DictionaryValuesHasher.call(metrics, values_at)

=> 'a74aacbae6a63736b34e142820957d88aa2fb3212a89b06c0a413d7c750a95b6'
```

## Development

After checking out the repo, run `bin/setup` to install dependencies. You can also run `bin/console` for an interactive prompt that will allow you to experiment.

To install this gem onto your local machine, run `bundle exec rake install`. To release a new version, update the version number in `version.rb`, and then run `bundle exec rake release`, which will create a git tag for the version, push git commits and tags, and push the `.gem` file to [rubygems.org](https://rubygems.org).

## Contributing

Bug reports and pull requests are welcome on GitHub at https://github.com/[USERNAME]/hashtastic. This project is intended to be a safe, welcoming space for collaboration, and contributors are expected to adhere to the [Contributor Covenant](http://contributor-covenant.org) code of conduct.

## License

The gem is available as open source under the terms of the [MIT License](https://opensource.org/licenses/MIT).

## Code of Conduct

Everyone interacting in the Hashtastic project’s codebases, issue trackers, chat rooms and mailing lists is expected to follow the [code of conduct](https://github.com/[USERNAME]/hashtastic/blob/master/CODE_OF_CONDUCT.md).
